live-build/helpers/lh_binary_usb-hdd

169 lines
3.6 KiB
Plaintext
Raw Normal View History

2007-09-23 08:04:46 +00:00
#!/bin/sh
2007-09-23 08:05:11 +00:00
# lh_binary_usb-hdd(1) - build binary usb-hdd image
2007-09-23 08:04:48 +00:00
# Copyright (C) 2006-2007 Daniel Baumann <daniel@debian.org>
#
# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
# This is free software, and you are welcome to redistribute it
# under certain conditions; see COPYING for details.
2007-09-23 08:04:46 +00:00
set -e
2007-09-23 08:05:11 +00:00
# Including common functions
LH_BASE="${LH_BASE:-/usr/share/live-helper}"
for FUNCTION in "${LH_BASE}"/functions/*.sh
2007-09-23 08:04:46 +00:00
do
2007-09-23 08:05:11 +00:00
. "${FUNCTION}"
2007-09-23 08:04:46 +00:00
done
2007-09-23 08:05:11 +00:00
# Setting static variables
2007-09-23 08:04:48 +00:00
DESCRIPTION="build binary image"
HELP=""
USAGE="${PROGRAM} [--force]"
Arguments "${@}"
2007-09-23 08:04:46 +00:00
# Reading configuration files
2007-09-23 08:04:52 +00:00
Read_conffile config/common
2007-09-23 08:04:46 +00:00
Read_conffile config/bootstrap
2007-09-23 08:04:49 +00:00
Read_conffile config/chroot
2007-09-23 08:04:52 +00:00
Read_conffile config/binary
Read_conffile config/source
2007-09-23 08:04:46 +00:00
Set_defaults
2007-09-23 08:05:11 +00:00
if ! echo "${LIVE_BINARY_IMAGES}" | grep -qs usb-hdd
then
exit 0
fi
Echo_message "Begin building binary usb-hdd image..."
# Requiring stage file
Require_stagefile .stage/bootstrap
Require_stagefile .stage/chroot_proc
# Checking stage file
Check_stagefile .stage/binary_usb-hdd
# Checking lock file
Check_lockfile .lock
# Creating lock file
Create_lockfile .lock
# Checking depends
Check_package chroot/sbin/mkdosfs dosfstools
Check_package chroot/usr/sbin/mtools mtools
Check_package chroot/sbin/parted parted
case "${LIVE_BOOTLOADER}" in
grub)
Check_package chroot/usr/sbin/grub grub
;;
syslinux)
Check_package chroot/usr/bin/syslinux syslinux
;;
esac
# Installing depends
Install_package
# Remove old binary
if [ -f binary.img ]
then
rm -f binary.img
fi
# Everything which comes here needs to be cleaned up,
DU_DIM="`du -ms binary | cut -f1`"
REAL_DIM="`expr ${DU_DIM} + ${DU_DIM} / 50`" # Just 2% more to be sure, need something more sophistcated here...
2007-09-23 08:05:12 +00:00
dd if=/dev/zero of=chroot/binary.img bs=1024k count=${REAL_DIM}
2007-09-23 08:05:11 +00:00
FREELO="`${LH_LOSETUP} -f`"
if [ ! -b chroot/${FREELO} ]
then
MAKEDEV="true"
mv chroot/dev chroot/dev.tmp
find /dev | cpio -dmpu chroot
fi
echo "!!! The following error/warning messages can be ignored !!!"
2007-09-23 08:05:12 +00:00
lh_losetup $FREELO chroot/binary.img 0
2007-09-23 08:05:11 +00:00
Chroot "parted -s ${FREELO} mklabel msdos" || true
Chroot "parted -s ${FREELO} mkpartfs primary fat16 0.0 100%" || true
Chroot "parted -s ${FREELO} set 1 boot on" || true
Chroot "parted -s ${FREELO} set 1 lba off" || true
2007-09-23 08:05:12 +00:00
if [ "${LIVE_BOOTLOADER}" = "syslinux" ]
then
cat chroot/usr/lib/syslinux/mbr.bin > ${FREELO}
fi
2007-09-23 08:05:11 +00:00
${LH_LOSETUP} -d ${FREELO}
FREELO="`${LH_LOSETUP} -f`"
2007-09-23 08:05:12 +00:00
lh_losetup $FREELO chroot/binary.img 1
2007-09-23 08:05:11 +00:00
Chroot " mkfs.vfat -F 16 -n DEBIAN_LIVE ${FREELO}"
2007-09-23 08:05:12 +00:00
mkdir -p chroot/binary.tmp
${LH_ROOT_COMMAND} mount ${FREELO} chroot/binary.tmp
cp -r binary/* chroot/binary.tmp
FIXME()
{
if [ "${LIVE_BOOTLOADER}" = "grub" ]
then
cat > chroot/grub.sh << EOF
cd binary.tmp
grub --batch << EOM
find /live/vmlinuz
EOM
EOF
rootpartition="`Chroot 'sh grub.sh' 2>/dev/null | grep -A 1 'find /live/vmlinuz' | grep -v 'find /live/vmlinuz'`"
usbdev="`echo $rootpartition | sed -e 's/,[[:digit:]]//'`"
echo "Root partition is $rootpartition, device is: $usbdev"
echo "WAITING..." && read
#cat > chroot/grub.sh << EOF
#grub --batch << EOM
#root $rootpartition
#setup $usbdev
#EOM
#EOF
#Chroot "sh grub.sh"
rm -f chroot/grub.sh
fi
}
${LH_ROOT_COMMAND} umount chroot/binary.tmp
rmdir chroot/binary.tmp
2007-09-23 08:05:11 +00:00
if [ "${LIVE_BOOTLOADER}" = "syslinux" ]
then
Chroot "syslinux ${FREELO}"
fi
${LH_LOSETUP} -d ${FREELO}
echo "!!! The above error/warning messages can be ignored !!!"
if [ -n "${MAKEDEV}" ]
then
rm -f chroot/dev
mv chroot/dev.tmp chroot/dev
fi
2007-09-23 08:05:12 +00:00
mv chroot/binary.img ./
2007-09-23 08:05:11 +00:00
# Removing depends
Remove_package
# Creating stage file
Create_stagefile .stage/binary_usb-hdd